unit u_slpash;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ComCtrls, ExtCtrls, LazUTF8;

type
  { TFrmSplash }

  TFrmSplash = class(TForm)
    Img: TImage;
    ImgList: TImageList;
    MyTmr: TTimer;
    sttTextCont: TStaticText;
    procedure FormCreate(Sender: TObject);
    procedure MyTmrTimer(Sender: TObject);
  private
    FInMsgStr: String;
    FNumFrame,
    FDotCount: Integer;
    DotTick,
    FrameTick: QWord;
    DotInt,
    FrameInt: Integer;
    procedure SetInMsgStr(AValue: String);
  public
    property InMsgStr: String read FInMsgStr write SetInMsgStr;
  end;

var
  FrmSplash: TFrmSplash;

implementation

{$R *.lfm}

{ TFrmSplash }

procedure TFrmSplash.MyTmrTimer(Sender: TObject);
begin
  if ((GetTickCount - DotTick) > DotInt) and (UTF8Trim(InMsgStr) <> '') then
    begin
      DotTick:= GetTickCount;

      case FDotCount of
        1: sttTextCont.Caption := InMsgStr;
        2: sttTextCont.Caption := InMsgStr + ' .';
        3: sttTextCont.Caption := InMsgStr + ' ..';
        4: sttTextCont.Caption := InMsgStr + ' ...';
      end;

      Inc(FDotCount);

      if FDotCount > 4 then FDotCount:= 1;
    end;

  if (GetTickCount - FrameTick) > FrameInt then
  begin
    FrameTick:= GetTickCount;

    //if ImageList is empty then show application's static icon
    if ImgList.Count = 0
      then
        Img.Picture.Icon:= Application.Icon
      else
        ImgList.GetBitmap(FNumFrame, Img.Picture.Bitmap);

    Inc(FNumFrame);

    //begin with the first picture if have reached the last
    if FNumFrame > pred(ImgList.Count) then FNumFrame := 0;
  end;


end;

procedure TFrmSplash.SetInMsgStr(AValue: String);
begin
  if FInMsgStr = AValue then Exit;
  FInMsgStr:=AValue;
end;

procedure TFrmSplash.FormCreate(Sender: TObject);
begin
  sttTextCont.Caption:= '';
  sttTextCont.DoubleBuffered:= True;
  InMsgStr:= '';

  DoubleBuffered:= True;
  Position:= poOwnerFormCenter;
  ShowInTaskBar:= stNever;
  BorderIcons:= BorderIcons - [biMaximize, biMinimize, biSystemMenu];
  BorderStyle:= bsSingle;
  Caption:= '';
  KeyPreview:= True;
  Constraints.MinHeight:= Height;
  Constraints.MinWidth:= Width;

  FDotCount:= 1;//counter of points in line
  FNumFrame:= 0;//number ImageList's current picture

  DotTick:= GetTickCount;
  FrameTick:= GetTickCount;
  DotInt:= 500;
  FrameInt:= 60;
  MyTmr.Interval:= 60;
  MyTmr.Enabled:= True;
end;

end.

