unit u_thread_03;

{$mode objfpc}{$H+}

interface

uses
  Classes,
  SysUtils,
  FileUtil,
  Forms,
  Controls,
  Graphics,
  Dialogs,
  StdCtrls,
  LCLType,
  LCLIntf,
  LMessages,
  LResources,
  LazUTF8;

const
  LM_MY_MSG = LM_USER + $101;
  LM_KILLSPLASH_MSG = LM_USER + $102;

type
  { TMyThread }

  TMyThread = class(TThread)
  private
    FIsTErminated: boolean;
  protected
    procedure Execute; override;
  public
    constructor Create(CreateSuspended: boolean);
  end;

  { TFrmMain }

  TFrmMain = class(TForm)
    btnAdd: TButton;
    procedure btnAddClick(Sender: TObject);
    procedure LMMyMsg(var Msg: TLMessage); message LM_MY_MSG;
    procedure LMKillSplashMsg(var Msg: TLMessage); message LM_KILLSPLASH_MSG;
  private
    { private declarations }
    FMyThread: TMyThread;

  public
    { public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

uses u_slpash;

const
  ShortStr: String = 'This is a short string';
  LongStr: String = 'Imaging''s source code repository at SourceForge has been migrated from Subversion to '
    + 'Mercurial. Subversion repository will still be updated for some time (probably till 0.80 release). In '
    + 'the side menu on the right you can now find list of the latest commits in Imaging''s repository. It''s '
    + 'based on RSS feed provided by HgWeb. I also prepared listing of feeds from Imaging forum and '
    + 'Imaging-related blog posts but unfortunatelly SourceForge doesn''t allow outside connections from '
    + 'project web sites that they are hosting';

{$R *.lfm}

{ TMyThread }

procedure TMyThread.Execute;
var
  s: string;
begin
  s:= ShortStr;
  PostMessage(FrmMain.Handle,LM_MY_MSG,0,LPARAM(NativeInt(s)));
  Sleep(2000);


  s:= LongStr;
  PostMessage(FrmMain.Handle,LM_MY_MSG,0,LPARAM(NativeInt(s)));
  Sleep(2000);

  s:= ShortStr;
  PostMessage(FrmMain.Handle,LM_MY_MSG,0,LPARAM(NativeInt(s)));
  Sleep(2000);

  s:= LongStr;
  PostMessage(FrmMain.Handle,LM_MY_MSG,0,LPARAM(NativeInt(s)));
  Sleep(2000);

  PostMessage(FrmMain.Handle, LM_KILLSPLASH_MSG, 0, 0);
end;

constructor TMyThread.Create(CreateSuspended: boolean);
begin
  inherited Create(CreateSuspended);
  Priority := tpLower;
  FreeOnTerminate := False;
  FIsTErminated := False;
end;

{ TFrmMain }

procedure TFrmMain.btnAddClick(Sender: TObject);
begin
  FMyThread := TMyThread.Create(True);
  try
    FrmSplash := TFrmSplash.Create(Application);
    FMyThread.Start;
    try
      FrmSplash.ShowModal;
    finally
      FreeAndNil(FrmSplash);
    end;
  finally
    FreeAndNil(FMyThread);
  end;
end;

procedure TFrmMain.LMMyMsg(var Msg: TLMessage);
var
  AText: String;
  ARect: TRect;
  h: Integer; //height of the drawn text
  AFlag: UINT;
  SplashCenterPnt: TPoint;
  DiffHeight: Integer;//difference between a splash height and textcontainer height
begin
  ARect:= Rect(-500,0, FrmSplash.sttTextCont.Width - 500,0);
  AText:= String(NativeInt(Msg.lParam));

  with Self.Canvas do
  begin
    //uses LCLType
    AFlag:= DT_CALCRECT or DT_WORDBREAK or DT_LEFT;

    //uses LCLIntf
    h:= DrawText(Handle,PUTF8Char(AText),UTF8Length(AText), ARect, AFlag);
  end;

  with FrmSplash do
  begin
    sttTextCont.Caption:= '';
    SplashCenterPnt.y:= Top + Height div 2;//a middle splash height
    DiffHeight:= Height - sttTextCont.Height;
    Height:= h + 15 + DiffHeight;

    {$IFDEF LCLGTK2}
    DoSetBounds(Left,SplashCenterPnt.y - Height div 2,Width,Height);
    {$ELSE}
    Top:= SplashCenterPnt.y - Height div 2;
    {$ENDIF}

    InMsgStr:= AText;
  end;
end;

procedure TFrmMain.LMKillSplashMsg(var Msg: TLMessage);
begin
  if Assigned(FrmSplash) then
    FrmSplash.Close;
end;

end.
